server {
    listen 80;
    server_name localhost;
    root /usr/share/nginx/html;
    index index.html;

    location / {
        # Esta es la parte que soluciona el 404 al recargar:
        try_files $uri $uri/ /index.html;
    }
}